'SavePath.BAS - Part of the QBFonts package.
'-------------------------------------------
'!!!! You must have this constant correctly defined, or the
'!!!! progam will not know what it's looking for.
CONST PROGRAMNAME = "SAVEPATH.BAS"

'  By Bobby K. of Insanity Dreams
'  If you use these subs in any of your programs please give
'  full credit to the author.
'  This program is copywrited, and may not be used for any
'  commercial purposes without the authors consent
'  E-Mail me at:
'    christie@intonet.co.uk
'    (Replys may take a while, as i'm off to Manchester uni soon :)
'  Visit the insanity dreams homepage at:
'    laz.home.ml.org
'    And click on the insanity dreams logo.  (My uni e-mail will probably
'    be in there as well.)
'
'
'This program "remebers" which path it resides in.
'if it can't find itself, it asks the user where it is, and
'the next time it is run, will use the new path.
'You are advised to reopen the program if you want to run it
'more than once in the same QB session.  This is because the
'program QB has stored in memory, will not be the same as the
'modified program, with the remembered path.
'This self modifying program works in QB, QB 4.5 AND .EXE file formats!
'The path is stored in the variable SAVEDpath
'The subroutine is called AAA.SAVEinitialise


'The AAA. part puts it in front of other subs, so that the path saver bytes
'are closer to the start of the program.
DECLARE SUB AAA.SAVEinitialise ()
DECLARE SUB SAVEinputpathtofile (a$)
DECLARE FUNCTION SAVEfind (Path$)
DECLARE FUNCTION SAVEgetpath$ ()
DIM SHARED SAVEDpath AS STRING
DIM SHARED BadPathName AS INTEGER

GOTO SkipErrorHandler
BadPath:
  BadPathName = TRUE
  RESUME NEXT
SkipErrorHandler:

'And just to prove that it works...
AAA.SAVEinitialise
CLS
PRINT "The path for your accompanying files is: " + SAVEDpath
PRINT "This program is: " + SAVEDpath + PROGRAMNAME
PRINT "Now quit, and exit QB, and re-run this program to see the the path is saved"
PRINT "Try it with .EXEs, and QB 4.5 file format - it still works."

SUB AAA.SAVEinitialise
  'DO NOT DUPLICATE THE BELOW TEXT ANYWHERE IN YOUR
  'PROGRAM, IN EITHER CODE, LITERAL STRINGS OR REMARKS.
  'It could invalidate the SAVEpath subroutines, or
  'even cause the complete corruption of .exe files!
  a$ = "fInDwOrD@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@"
 
  DatPath$ = MID$(a$, 9, 50)
  FOR count = 1 TO 50
    IF MID$(DatPath$, count, 1) = "@" THEN
      DatPath$ = LEFT$(DatPath$, count - 1)
      EXIT FOR
    END IF
  NEXT count
  DatPath$ = LTRIM$(RTRIM$(DatPath$))
  IF SAVEfind(DatPath$ + "FINDER.DAT") THEN
    SAVEDpath = DatPath$
  ELSE
    DO
      a$ = SAVEgetpath$
      found = SAVEfind(a$ + "FINDER.DAT")
    LOOP UNTIL found
    PRINT "File located."
    PRINT "Searching for saver bytes.  Please wait."
    SAVEinputpathtofile a$
    SAVEDpath = a$
    PRINT "Bytes found and modified."
    COLOR 4
    PRINT "If this program is in .BAS form,"
    PRINT "It is advised that you reopen the program after the program has been run."
    PRINT "Do not save the program."
  END IF

END SUB

FUNCTION SAVEfind (Path$)
  SAVEfind = TRUE
  ON ERROR GOTO BadPath
  BadPathName = FALSE
  OPEN Path$ FOR RANDOM AS #1 LEN = 2
  IF BadPathName THEN
    SAVEfind = FALSE
    EXIT FUNCTION
  END IF
  IF LOF(1) = 0 THEN
    SAVEfind = FALSE
  ELSE
    CLOSE
    OPEN Path$ FOR INPUT AS #1
    LINE INPUT #1, header$
    IF header$ <> "Finder Header Text" THEN SAVEfind = FALSE
  END IF
  CLOSE
END FUNCTION

FUNCTION SAVEgetpath$
  CLS
  SCREEN 0
  COLOR 7
  PRINT "Could not find the .QBF files!"
  PRINT
  PRINT "Please include full path (e.g. D:\BobbyK\Fonts)"
  PRINT "Type q to quit"
  INPUT "Where do they reside"; a$
  IF a$ = "q" THEN SYSTEM
  IF LEFT$(a$, 1) <> "\" THEN a$ = a$ + "\"
  SAVEgetpath$ = a$

  IF LEN(a$) > 50 THEN
    PRINT "Damn!  Too long!"
    PRINT "Move the file to a path with a shorter name"
    SLEEP
    SYSTEM
  END IF

END FUNCTION

SUB SAVEinputpathtofile (a$)
  DIM singlebyte AS STRING * 1
  DIM byte(8) AS STRING * 1
  OPEN a$ + PROGRAMNAME FOR RANDOM AS #1 LEN = 1
  record = 0
  DO
    record = record + 1
    byte(8) = byte(7): byte(7) = byte(6): byte(6) = byte(5)
    byte(5) = byte(4): byte(4) = byte(3): byte(3) = byte(2)
    byte(2) = byte(1): GET #1, record, singlebyte: byte(1) = singlebyte
    IF byte(8) = "f" THEN
      IF byte(7) = "I" AND byte(6) = "n" AND byte(5) = "D" AND byte(4) = "w" AND byte(3) = "O" AND byte(2) = "r" AND byte(1) = "D" THEN
        FOR n = 1 TO LEN(a$)
          singlebyte = MID$(a$, n, 1)
          PUT #1, record + n, singlebyte
        NEXT n
        FOR n = LEN(a$) + 1 TO 50
          singlebyte = "@"
          PUT #1, record + n, singlebyte
        NEXT n
        EXIT SUB
      END IF
    END IF
  LOOP UNTIL EOF(1)
  PRINT "Unexpected error!"
  PRINT "The path you specified was located."
  PRINT "A file with the correct header text was also found."
  PRINT "However, it was not found to have any path saving bytes."
  SLEEP
  SYSTEM
  CLOSE
END SUB

